{===============================================================================
 === Projet : GraphGen
 ===    Algorithe gntique pour rsoudre le problme du voyageur de commerce
 ===============================================================================
 === Auteur : Alexandre AUPETIT (aaupetit@club-internet.fr)
 ===    Voir mon site http://home.alex.tuxfamily.org/pvc.html
 ===     propos du problme du voyageur de commerce et des
 ===    algorithmes gntiques. Participez au dfi des 250 villes !
 ===    Vous trouverez galement mon programme tspgen, logiciel
 ===    libre crit en C++, et environ 50 fois plus performant
 ===    que celui-ci
 ===============================================================================
 === Licence : Logiciel libre sous licence GNU GPL
 ===    Ce logiciel doit toujours tre distribu avec ses sources
 ===    Vous avez le droit de modifier librement ces sources (et vous y
 ===    tes mme encourags)  condition que les modifications soient
 ===    galement libres (voir le fichier LICENCE.txt)
 ===============================================================================
 === Version  : 1.0.0
 === Date de cration : 10/08/1997
 === Date de dernire modif : 26/04/2003
 ===============================================================================
 === Fichier : Utilitaires
 ===============================================================================
 === RAF : messages d'erreur
 ==============================================================================}

unit Genutil;

interface

uses
  SysUtils, Messages, Classes;

const
  NB_ELEMENTS_MAX = 100;
  NB_INDIVIDUS_MAX = 100;
  NB_SOUSPOPULATIONS_MAX = 10;
  TEMPO_MAX = 500;

type
  TMut = (tmEchange, tmRenversement, tmEchangeRapproche, tmDecalage);
  TEvol = (teHasard, teMonteCarlo, teDarwin);
  TSel = (tsHasard, tsPremiers, tsProche);

procedure InitHasard;

function Hasard(iMax : integer) : integer;

function Hasardx2(iMax : integer) : integer;

function Hasardx3(iMax : integer) : integer;

procedure Echange(var a : integer; var b : integer);

//procedure tic;

//procedure tac;

//procedure Delay(iMiliSecondes : integer);

function Circ(iNb : integer; iMax : integer) : integer;

implementation

uses Windows;

{========================================================================
  === Fonction : initialise la liste de nb aleatoires
  ========================================================================}
procedure InitHasard;
begin
  Randomize;
end;


{========================================================================
 === Fonction : renvoie un nb aleatoire entier entre 1 et max
 === Entree : max : l'entier maximum
 === Retour : le nb aleatoire
 ========================================================================}
function Hasard(iMax : integer) : integer;
begin
  result := Random(iMax) + 1;
end;


{************************* autre fonction ?????  }
{ Hasard(Hasard()) }
{========================================================================
 === Fonction : renvoie un nb aleatoire entier entre 1 et max
 ===            avec une probabilite plus grande pour 1 que pour max
 === Entree : max : l'entier maximum
 === Retour : le nb aleatoire
 ========================================================================}
function Hasardx2(iMax : integer) : integer;
var
  x : real;
begin
  x := Hasard(20*iMax)/(20*iMax);
  result := round((1 - sqrt(sqrt(x)))*iMax + 1);
end;


function Hasardx3(iMax : integer) : integer;
begin
  result := Circ(round((Hasard(iMax)*4)/3), iMax);
end;




{========================================================================
 === Fonction : echange entre deux entiers
 === Entree : a et b : les deux entiers a echanger
 === Sortie : a et b echanges
 ========================================================================}
procedure Echange(var a : integer; var b : integer);
var
 iInter : integer;
begin
  iInter := a;
  a := b;
  b := iInter;
end;

function Circ(iNb : integer; iMax : integer) : integer;
begin
  if iNb < 1 then
    result := iNb + iMax
  else if iNb > iMax then
    result := iNb - iMax
  else
    result := iNb;
end;


procedure tic;
begin
  //MessageBeep(0);
end;

procedure tac;
begin
  //MessageBeep(1);
end;


end.
